#!/usr/bin/perl -w
# Perl script to generate names travesty style

#Perl -Sx "{0}" {"Parameters"}
#Exit

use strict;
require "getopts.pl";

#&Getopts( 'o:c:' );
#
#$order = 3;
#if ($opt_o != 0) { $order = $opt_o; }
#$Order > 0 || die "Order must be at least 1\n";

my (@words, %wordlist, %dict3, %dict2, $word, $newword);
my $wordcount = 100;
#if ($opt_c != 0) { $wordcount = $opt_c; }

srand;

# Default name list
if ($#ARGV == -1) { @ARGV = ( "FantasyNames.txt" ); }

# Read all input words and put into associative array
while (<>)
{
    next if (/^\#/);

    @words = split( /\s/, $_ );
    foreach $word (@words)
    {
	# Convert to lower case
	$word =~ tr/A-Z/a-z/;
	$wordlist{ $word } = 1;
    }
}

	#	Build probability tables for words
my @srcwords = keys %wordlist;

foreach $word (@srcwords) {

    my $index;

    #	Can't deal with names that are shorter than the order.
    next if (length ($word) <= 2);
	
    #	For each order-length patthen of characters in the word
    for ($index = 0; $index < length( $word ) - 3; $index++)
    {
	#	Add pattern to dictionary.
	$dict3{ substr( $word, $index, 3 ) } .= substr( $word, $index + 3, 1 );
    }

    #	Add word end to dictionary
    $dict3{ substr( $word, $index, 3 ) } .= ' ';

    #	For each order-length patthen of characters in the word
    for ($index = 0; $index < length( $word ) - 2; $index++)
    {
	#	Add pattern to dictionary.
	$dict2{ substr( $word, $index, 2 ) } .= substr( $word, $index + 2, 1 );
    }

    #	Add word end to dictionary
    $dict3{ substr( $word, $index, 2 ) } .= ' ';
}

$| = 1;

for my $i (1..$wordcount) {

    for (;;) {
	my $startword = $srcwords[ int(rand $#srcwords + 1) ];
	$newword = substr( $startword, 0, 3 );
	my ($index, $prob, $char);

	for ($index = 0; $index < 11; $index++) {
	    $prob = $dict3{ substr( $newword, $index, 3 ) };
	    if (!defined( $prob ) || length( $prob ) == 1) {
		$prob = $dict2{ substr( $newword, $index + 1, 2 ) };
	    }
	    last if (!defined( $prob ));
	    $char = substr( $prob, int(rand (length( $prob ))), 1 );
	    last if ($char eq ' ');
	    $newword .= $char;
	}
	my $length = $index + 3;
	next if ($length >= 11 || $length < 4);
	next if (defined $wordlist{ $newword });
	last;
    }

    #	Capitalize
    substr( $newword, 0, 1 ) =~ tr/a-z/A-Z/;
	
    printf "%-16s ", $newword;
    print "\n" if ($i % 5 == 0);
}
1;
