#!/usr/bin/perl -w
# Perl script to generate random word combinations

#Perl -Sx "{0}" {"Parameters"}
#Exit

use strict;

$| = 1;

my @adj_list = (
	# colors
	"red","blue","yellow","purple","green","orange","black","white","grey","golden",
	"crimson","rose","violet","scarlet",
#	brown","tan","indigo,
#	pink","maroon","magenta","aqua","turquoise,

	# general adj
	"hard","low","near","far","over","under","north","south","west","east",
	"little","small","tiny","flat",

	"deep","giant","wild","mystic","twin","windy",
	"straight","twisted","crooked","winding",
	"slow","bald","lame","old","olden","odd","pale",

	# competent
	"sleek","swift","fleet","quick","fast",				# fast
	"big","great","tall","high","long",				# big
	"strong","burly","stout","hale","hearty",			# strong
	"wise","lucky","merry","noble",

	# benevolent
	"true","safe","brave","fair","bright","pure","bonny","gay",

	# threatening
	"deadly","demonic","horned","hulking","killer","phantom","moaning",
	"nether","ghost","hell","dire","fell","mean","wicked",

	# other adj
	"bitter","dour","fey","strange","lone","giddy","mad",
	"muddy","dirty","murky","fiery","savage",
	"lunar","solar","vile",

	# numbers
	"three","four","five",

	# Adjectives that are really verbs
	"dancing","flying","leaping","growling","howling","shining",
	"rising","roaring","running","singing","sleeping","flaming",
	"crawling","watching","killing","burning","healing",
);

my @substance_list = (
	"light","sun","moon","star","glow","flash","shine",			# light	
	"dark","shadow","shade","murk","night",					# dark
	"fire","flame","lightning","summer","heat","ash","smoke","spark",	# fire
	"earth","stone","marble","sand","mud","dirt","rock","land","granite",	# earth
	"air","wind","breeze","thunder","storm","cloud","tempest",		# air
	"water","sea","ice","frost","mist","snow","winter",			# water
	"phaze","power","force","might",				# other forces
	"charm","fame","wit","guile",					# talents
	"bone","blood","carrion","flesh","slime","gut",			# flesh
	"copper","iron","bronze","gold","brass","silver",			# metals
	"jet","amber","emerald","diamond","ruby","sapphire","topaz","jade",	# gems
	"glass",

	# other substances
	"brandy","ale","mead","honey","meat","bread","bacon","pork","beef",
	"barley","corn","brew",
	"web","poison","bile",
	"money","cargo",

	# not substances, but states...
	"battle","war","doom","evil","death","siege",
	"harm","life","pain","plague","truth",
	"sleep",

	# emotions
	"joy","love","sorrow","hate","fear","dread","grief","pride","woe","lust",
	"wrath",
);

my @noun_list = (

	# mammals
	"chicken","cow","deer","dog","ferret","fox","goat","hare","hinds","hog",
	"badger","bat","bear","beaver","bees","boar","calf","cat","cattle",
	"horse","hound","jackal","lamb","lion","moose","mouse","mule","otter",
	"pig","rabbit","ram","rat","sheep","squirrel","stag","tiger","viper",
	"weasel","wolf","beast","bull","ox",

	# birds
	"bird","eagle","falcon","hawk","lark","swan","owl","raven","robin","fowl",
	"crow",

	# reptiles
	"snake","frog","lizard","tortise","turtle",

	# other animal
	"ants","crawler","bug","wasp","spider","crab","fish","worm","scorpion",
	
	# plants
	"flower","petal","tree","rose","leaf","oak","ash","cherry","pine","willow",
	"weed",

	# mythical beasts
	"dragon","demon","devil","spirit","ghost","fiend","goblin",
	
	# people
	"witch","mage","priest","warrior","pirate","slaver","guard","knight",
	"lord","smith","wizard","thief","man","woman","maiden","sage","robber",
	"sheperd","drover","scout","traveler","hero","folk","slave","thrall",
	"rogue","monk","spy",

	# relationships	
	"brother","sister","father","mother","child","kin",

	# arms
	"sword","hammer","mace","blade","shield","spear","bow","arrow","whip",
	"sabre","dagger","knife","helm","arms","dart","flail","net","rod","wand",
	"staff",

	# habitations
	"town","village","city","castle","keep","farm","inn","tavern","haven",
	"temple","road","bridge","ford","ferry",

	# terrain
	"cavern","crag","canyon","plain","mountain","hill","forest","wood",
	"grove","lake","river","stream","ocean","cave","swamp","jungle","desert",
	"pond","fell","dale","vale","isle","dock","world","pillar","valley",
	"creek","brook",

	# objects
	"ship","boat","craft","throne","scepter","grail","cup","chalice",
	"cloak","jewel","gem","crown","brand","torch","bugle","fiddle","harp",
	"drum","flute","banner","key","saddle","bridle","wheel",

	# containers
	"pot","kettle","jug","bottle","barrel","keg","cask","goblet","flask",
	"mug","wagon",

	# non-phys...
	"song","story","dream","rune","spell","tale","illusion","fate",
	"glamor","dance",

	# body parts
	"skull","head","heart","hand","finger","wing","paw","horn","eye",
	"tooth","foot","arm","leg","back","body","brain","face","fin","limb","soul",
	"boot",
);

my @doer_list = (
	"crafter","bringer","maker","shaper","stealer","winner","splitter",
	"burner","raiser","rider",
	"fighter","skinner","killer","herder","slayer","singer","teller",
	"dancer","spinner","weaver",
	"hunter","reaver","sower","reaper","monger","seller","warden","master","runner",
	"watcher","giver","taker","holder","keeper","lover","poacher","player",
	"wright","leader",
	"sculptor","whacker","breaker","crusher","smiter","striker","bearer",
	"binder","caster","dealer",
	"sender","lord","marshal","walker","cleaver","cutter","smasher","handler",
	"tamer","tracker",
	"trader","slayer","drinker","crawler","finder","seeker","eater",
);

	#	List of word combination templates.
my @combo_list = (
	"{adj} {noun}",
	"{noun} {noun}",
	"{substance} {noun}",
	"{adj} {substance}",
	"{substance} {substance}",
	"{adj} {doer}",
	"{substance} {doer}"
);

my $wordcount = 50;

srand;

for my $num (1..$wordcount) {

    # Select a template
    my $template = $combo_list[ rand( $#combo_list + 1 ) ];

    # Transform into executable expression
    $template =~ s/\{([^\}]+)\}/\$$1_list\[ rand\( \$\#$1_list \+ 1 \) \]/g;

    # Print the expression
    printf "%-17s ", eval( '"' . $template . '"' );

    # print EOL if needed.
    print "\n" if ($num % 5 == 0);
}

1;
